/*
 * Copyright (C) 2018-2022 Toshiaki Maki <makingx@gmail.com>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.xbib.datastructures.validation.constraint.base;

import java.util.Deque;
import java.util.LinkedList;

import org.xbib.datastructures.validation.core.Constraint;
import org.xbib.datastructures.validation.core.ConstraintPredicate;

public abstract class ConstraintBase<T, V, C extends Constraint<T, V, C>>
		implements Constraint<T, V, C> {
	private final Deque<ConstraintPredicate<V>> predicates = new LinkedList<>();

	@Override
	public Deque<ConstraintPredicate<V>> predicates() {
		return this.predicates;
	}
}
