/*
 * Copyright (C) 2018-2022 Toshiaki Maki <makingx@gmail.com>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.xbib.datastructures.validation.fn;

/**
 * Generated by
 * https://github.com/making/yavi/blob/develop/scripts/generate-applicative.sh
 *
 * @since 0.6.0
 */
public class Combining1<E, T1> {
	protected final Validation<E, T1> v1;

	public Combining1(Validation<E, T1> v1) {
		this.v1 = v1;
	}

	public <R, V extends Validation<E, R>> V apply(Function1<T1, R> f) {
		return v1.apply(Validation.success(Functions.curry(f)));
	}

	public <T2> Combining2<E, T1, T2> combine(Validation<E, T2> v2) {
		return new Combining2<>(v1, v2);
	}
}
